 /* Reten 27-05-2000    */
/* (c) SETA   Dominio Publico  */
/* xWin  */

#include <unistd.h>
#include <string.h>
#include <time.h>

#include "stdio.h"
#include "stdlib.h"
#include <sys/time.h> 

#include "xxgrafi.h"
#include "objetos.h"

#include "main.h"


#define TIEMPO1		10


#if YesWindows
    static 	char *myport[]= {"com1","com2","com3","com4","com5","com6","com7","com8","com9","\\\\.\\COM10","\\\\.\\COM11","\\\\.\\COM12"};
#else
	static char *myport[]= {(char *)"/dev/ttyUSB0", (char *)"/dev/ttyUSB1", (char *)"/dev/ttyACM0", (char *)"/dev/ttyACM1", (char *)"/dev/ttyACM2", (char *)"/dev/ttyS0", (char *)"/dev/ttyS1"};
#endif	

void Repaint(void);
int SearchPort(char *placa);
void analizarIN();
void MiTimer();

int tiempo1;

int canal=0,frecuencia=1035;

int  ContadorI=0;
char Binput[100];
char Binput2[10];

Boton *Bexit;
Boton *Bvolmas;
Boton *Bvolmenos;
Boton *Bbuscarmas;
Boton *Bbuscarmenos;
Boton *Bsintoniamas;
Boton *Bsintoniamenos;
Boton *Bextra;

TextoE *Efrecuencia;
TextoE *Ecanal;
TextoE *Edevice;

TextoS *Shercios;
TextoS *Scanal;
TextoS *Snombre;

int main (int argc, char *argv[])
{
 int z,zz,t,f2;
 int mouse_x,mouse_y;
 XEvent event;   
	init(430,146);
	SETBUFFER=1;
	zz=loadfont((char *)"nada");
	paleta();
	INK=5; 
                
	Bexit=new Boton(284,104,89,24,(char*) "EXIT");
	Bvolmas=new Boton(284,72,89,24,(char*) "vol>");
	Bvolmenos=new Boton(192,72,89,24,(char*) "<vol");
	Bsintoniamas=new Boton(100,104,89,24,(char*) ">");
	Bsintoniamenos=new Boton(8,104,89,24,(char*) "<");
	Bbuscarmenos=new Boton(8,72,89,24,(char*) "<<");
	Bbuscarmas=new Boton(100,72,89,24,(char*) ">>");	
	
	Efrecuencia=new TextoE(8,6,85,24,(char*) "Frecu");
	Ecanal=new TextoE(8,40,85,24,(char*) "Canal");
	Edevice=new TextoE(192,40,175,24,(char*) "no Device");	
	
	Shercios=new TextoS(100,8,(char*) "MHz");
	Scanal=new TextoS(100,40,(char*) "Canal");
	Snombre=new TextoS(192,8,(char*) "RadioARDU_XWIN");             
                                      
   	while(XPending(Midisplay))  XNextEvent (Midisplay, &event);    	
   	Repaint();   	
   
   	z=SearchPort((char*)"RADIO1=");
	if(z==-1)
			 { printf("No RADIO %d\n",z);}
			else
		     { 
				MODEMDEVICE=myport[z];
	#if YesWindows
				if(hSerial)CloseRs232();
	#else		
				if(fdrs232)CloseRs232();
	#endif		 
				IniRs232();
				Edevice->Value(MODEMDEVICE);
				Ecanal->Value(canal);
				Efrecuencia->Value(float(frecuencia)/10);
			 }
    Repaint();
   	
	while(27!=t)
	 {
		 DelayMs(10);	  
		 MiTimer();	
		 
          if(XPending(Midisplay))
                 {
                  XNextEvent (Midisplay, &event);
                  Mievent=&event;
	                 switch (event.type)
                         {
                         case Expose:
                            redraw();
                            break;
                         case KeyPress:
                            do_KeyPress ();
                            break;
                         case KeyRelease:
                            do_KeyRelease ();
                            break;
                          case MotionNotify:
                            mouse(3);
                            break;
                          case ButtonPress:
                            mouse(4);
                            break;
                          case ButtonRelease:
                            mouse(5);
                            break;
                         default:          
                            break;
                         }
                   Ecanal->Value(canal);
				   Efrecuencia->Value(float(frecuencia)/10);	
                  } 
         
                  t=inkey();
                  mouse_x=XMOUSE;
				  mouse_y=YMOUSE;	
                  SETBUFFER=1;
                  if(KMOUSE==0) f2=0;
                  if(f2==0 && CMOUSE==1 && KMOUSE==1 )
                   {
					   
					if(Bexit->get(mouse_x,mouse_y)) 
						{						 
						 goto fin;	
						}   
					if(Bvolmas->get(mouse_x,mouse_y)) 
						{
						 #ifdef DEBUG
							printf("B_vol+\n");
						 #endif
						 PrintSerial((char *)"volume+\n");
						 Bvolmas->Dibujar(1);
						 goto salir1;	
						}
					if(Bvolmenos->get(mouse_x,mouse_y)) 
						{
						 #ifdef DEBUG
							printf("B_vol-\n");
						 #endif
						 PrintSerial((char *)"volume-\n");	
						 Bvolmenos->Dibujar(1);
						 goto salir1;	
						}
					if(Bsintoniamas->get(mouse_x,mouse_y)) 
						{
						 #ifdef DEBUG
							printf("Sintomas\n");
						 #endif
						 if(canal < 210) canal++;
						 sprintf(VARI,"ncanal=%d\n",canal);
						 PrintSerial(VARI); 
						 Bsintoniamas->Dibujar(1);
						 goto salir1;	
						}
					if(Bsintoniamenos->get(mouse_x,mouse_y)) 
						{
						 #ifdef DEBUG
							printf("Sintomenos\n");
						 #endif
						 if(canal>0) canal--;
						 sprintf(VARI,"ncanal=%d\n",canal);
						 PrintSerial(VARI);  
						 Bsintoniamenos->Dibujar(1);
						 goto salir1;	
						}
					if(Bbuscarmas->get(mouse_x,mouse_y)) 
						{
						 #ifdef DEBUG
							printf("Buscarmas\n");
						 #endif
						 PrintSerial((char *)"buscar+\n"); 
						 Bbuscarmas->Dibujar(1);
						 goto salir1;	
						}
					if(Bbuscarmenos->get(mouse_x,mouse_y)) 
						{
						 #ifdef DEBUG
							printf("Buscarmenos\n");
						 #endif
						 PrintSerial((char *)"buscar-\n"); 
						 Bbuscarmenos->Dibujar(1);
						 goto salir1;	
						}					
					goto salir12;
salir1:						
					redraw();
					DelayMs(90);
salir12:   					   
                   // printf("mouse  XMOUSE=%d   YMOUSE=%d\n",XMOUSE,YMOUSE);
                    f2=1;                         
                   }
	 }
	 
fin:
		printf("Fin de programa xRadio\n");
	
mode(2);
}

void Repaint(void)
{	
	FONTY=2; FONTX=2;
	clear(6);
	C_PAPER=6;
	Bexit->Dibujar();
	Bvolmas->Dibujar();
	Bvolmenos->Dibujar();
	Bsintoniamas->Dibujar();
	Bsintoniamenos->Dibujar();	
	Bbuscarmas->Dibujar();
	Bbuscarmenos->Dibujar();
	
	FONTY=2; FONTX=1;
	Efrecuencia->Dibujar();
	Ecanal->Dibujar();
	Edevice->Dibujar();
	
	FONTY=2; FONTX=2;
	Shercios->Dibujar();	
	Scanal->Dibujar();
    Snombre->Dibujar();
    redraw();
}



void MiTimer()
{
 int nbytes;
 
	tiempo1--;	
// cada __tiempo1	
	if(tiempo1<0)
		{	
			tiempo1=TIEMPO1;
#ifdef DEBUG 
					printf("Tiempo1\n");
#endif

#if YesWindows			
			while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
			while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif			
			{
					//printf("Leer %d -> %s\n",ContadorI,Binput2);	
				Binput[ContadorI]=Binput2[0];
				ContadorI++;
				if (Binput2[0] == '\n')
				{
					if(ContadorI<2)ContadorI=2;   
					Binput[ContadorI-2]=0;
					ContadorI=0;	
#ifdef DEBUG 
					printf("Leidos-> %s\n",Binput);
#endif					
					sprintf(VARI,"%s",Binput);	
					analizarIN();
					Ecanal->Value(canal);
					Efrecuencia->Value(float(frecuencia)/10);	
					Repaint();																	
				}															
			}					
		}


}

//________________________________________
void analizarIN()
{

		if(!strncmp(VARI,"Canal=",6))
		{
			strncpy(Binput2,VARI+6,4);
			canal=atoi(Binput2);	 
#ifdef DEBUG 
			printf("OK_Canal =%d \n",canal);
#endif			
			goto salirpro;
		}
		if(!strncmp(VARI,"Frecuencia=",11)) 
		{
			strncpy(Binput2,VARI+11,4);
			frecuencia=atoi(Binput2);			 
#ifdef DEBUG 
			printf("OK_Frecuencia =%d \n",frecuencia);
#endif		
			goto salirpro;
		}
#ifdef DEBUG 		
		printf("->%s\n",VARI);
#endif		
		salirpro:
		;
}




//______________


//______________

int SearchPort(char *placa)
{
		int z,zz,nbytes;
		char temp[15];
		
		printf("Search serial\n");
//		PrintConsola((char *)"Search serial");
 #if YesWindows
		for (z=0;z<11;z++)
 #else
			for (z=0;z<7;z++)
 #endif		
			{
				MODEMDEVICE=myport[z];
				printf("Test Port %s\n",MODEMDEVICE);
//				PrintConsola(MODEMDEVICE);
				if(0==IniRs232())
				   {   
					printf("->busqueda>%s   %s\n",MODEMDEVICE,placa);            
					DelayMs(1500);
					PrintSerial((char *)"\n\n");
					sprintf(temp,"%s\n",placa); 	
					PrintSerial((char *) temp);			
					DelayMs(100);
					ContadorI=0; 
					for(zz=0;zz<20;zz++)
					   {
						DelayMs(100); 
#if YesWindows
						while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
						while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif		
							{	
//							    printf("Leerx %d -> %s\n",nbytes,Binput2);
								Binput[ContadorI]=Binput2[0];
								ContadorI++;
								if (Binput2[0] == '\n')
								   {
									if(ContadorI<2)ContadorI=2;   
									Binput[ContadorI-1]=0;
									ContadorI=0;	
									sprintf(VARI,"%s",Binput);
//                                    printf("==%s\n",VARI);
									if(!strncmp(VARI,"OK",2))
									   {
										printf("%s found at %s\n",placa,MODEMDEVICE);
										CloseRs232();                                   
										return z;
									   }			
								    }
							}	  	  
						} 
						 					 						   
					}

			 }
			printf("OSCI no found \n");
			return -1;
}

