#include <stdio.h>
#include <stdlib.h>

#include "define.h"


#if YesWindows 
 #include <windows.h>
  #define BAUDRATEW CBR_9600
#else
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <fcntl.h>
 #include <termios.h>
 #define BAUDRATE B9600
#endif


#if YesWindows 
extern HANDLE hSerial;
extern DCB dcbSerialParams;
extern    COMMTIMEOUTS time_out;
#else
extern	struct termios newtermios;
extern	int fdrs232;
#endif


extern char *MODEMDEVICE; 


#if YesWindows  
int WriteSerie(HANDLE hSerial,char *c,int tamano);
int ReadSerie(HANDLE hSerial,char *c,int tamano);
#endif



#ifndef _TEST_H       //  directivas de preprocesador estandares
#define _TEST_H       

//------------------------------------------------------------------
#ifdef __cplusplus      //  Estas tres lineas
extern "C" {              //  son parte de lo que 
#endif                     //  nos permite usar nuestro código en c y c++
// ------------------------------------------------------------------
extern int IniRs232();
extern int CloseRs232();

extern  void PrintSerial(char *cadena);
extern void DelayMs(unsigned int t);

//float calcMitad(int x);     // Declaración de nuestras funciones

//------------------------------------------------------------------
#ifdef __cplusplus       // estas tres lineas deben cerrar
}                              // las directivas de arriba
#endif
//------------------------------------------------------------------

#endif                     // directiva que cierra el ifndef principal


